<template lang="pug">
  div(class="blog-item" v-if="document.isDraft === false")
    BlogSearch/
    h1
      img(
        v-if="document.image"
        :src="document.image"
      )
      span {{ document.title }}
    div(class="blog-item__header")
      ul
        li(v-for="(availablePath, availableLocale) in availableArticleLocales()")
          a(:href="availablePath")
            IconTranslate()/
            span {{ $t("label.locales." + availableLocale) }}
        li
          IconTimer()/
          span {{ $tc('label.readingTimeExtended', Math.ceil(document.readingTime.minutes)) }}
        li
          IconClockClockwise()/
          span {{ $t('label.updatedAt', {updatedAt: $moment(document.updatedAt).fromNow()}) }}
        li
          IconCalendarBlank()/
          span {{ $t('label.createdAt', {createdAt: $moment(document.createdAt).format('ll')}) }}
    div(class="blog-item__content")
      nuxt-content(:document="document")/
      MiscCreativeCommons(:license="document.license" class="blog-item__content__cc")/
      BlogPreviousNext(:previous="articleSurround[0]" :next="articleSurround[1]" class="blog-item__content__pn")/
    div(class="blog-item__footer")
      ul
        li
          a(:href="gitContentUrl(document.path)" target="_blank")
            IconPencilLine()/
            span(class="") {{ $t('label.edit') }}
        li(v-if="document.license")
          IconCc()/
          span() {{ $t('label.licenseCc') }}
        li(v-if="document.author")
          IconIdentificationBadge()/
          a(v-if="document.email" :href="'mailto://' + document.email") {{ document.author }}
          span(v-else class="align-middle") {{ document.author }}
        li(v-if="document.linkedin")
          a(:href="document.linkedin" target="_blank" :title="$t('label.linkedin')")
            IconLinkedinLogo()/
            span() {{ $t('label.linkedin') }}
        li(v-if="document.github")
          a(:href="document.github")
            IconGithubLogo()/
            span() {{ $t('label.github') }}
        li(v-if="document.gitlab")
          a(:href="document.gitlab")
            IconGitlabLogo()/
            span() {{ $t('label.gitlab') }}
        li(v-if="document.buymeacoffee")
          a(:href="document.buymeacoffee" :title="$t('label.buymeacoffee')")
            IconBuyMeACoffeeLogo()/
            span() {{ $t('label.buymeacoffee') }}
</template>

<script>
import IconClockClockwise from '~/assets/svg/ph-clock-clockwise-fill.svg?inline';
import IconArrowCircleDownRight from '~/assets/svg/ph-arrow-circle-down-right-fill.svg?inline';
import IconHandPointingRight from '~/assets/svg/ph-hand-pointing-fill.svg?inline';
import IconTimer from '~/assets/svg/ph-timer-fill.svg?inline';
import IconPenNib from '~/assets/svg/ph-pen-nib-fill.svg?inline';
import IconCalendarBlank from '~/assets/svg/ph-calendar-blank-fill.svg?inline';
import IconIdentificationBadge from '~/assets/svg/ph-identification-badge-fill.svg?inline';
import IconLinkedinLogo from '~/assets/svg/ph-linkedin-logo-fill.svg?inline';
import IconGitlabLogo from '~/assets/svg/ph-gitlab-logo-fill.svg?inline';
import IconGithubLogo from '~/assets/svg/ph-github-logo-fill.svg?inline';
import IconPencilLine from '~/assets/svg/ph-pencil-line-fill.svg?inline';
import IconCc from '~/assets/svg/cc/cc.svg?inline';
import IconTranslate from '~/assets/svg/ph-translate-fill.svg?inline';
import IconBuyMeACoffeeLogo from '~/assets/svg/logo-buymeacoffee.svg?inline';

export default {
  name:       "BlogItem",
  components: {
    IconClockClockwise,
    IconArrowCircleDownRight,
    IconHandPointingRight,
    IconTimer,
    IconPenNib,
    IconCalendarBlank,
    IconIdentificationBadge,
    IconLinkedinLogo,
    IconGitlabLogo,
    IconGithubLogo,
    IconCc,
    IconPencilLine,
    IconTranslate,
    IconBuyMeACoffeeLogo,
  },
  props:      {
    document:        Object,
    articleSurround: Array,
  },
  methods:    {
    availableArticleLocales() {
      let locales = []
      let path = {}

      this.$i18n.availableLocales.forEach(locale => {
        if (locale !== this.$i18n.locale) {
          locales.push(locale)
        }
      })

      locales.forEach(locale => {
        let myPath = this.document.path

        if (this.document.language.includes(locale)) {
          path[locale] = myPath.replace(/^(\/[a-zA-Z]{2})/, '/' + locale)
        }
      })

      return path
    }
  }
}
</script>

<style lang="scss" scoped>
.blog {
  &-item {
    @apply
    p-2
    sm:p-0
    ;

    > h1 {
      @apply mt-4 text-xl;

      img {
        @apply
        h-10
        my-4
        inline-block
        mr-2
        fill-current
        align-middle
        shadow
        grayscale
        hover:grayscale-0
        ;
      }
    }

    &__content {
      @apply
      bg-gray-200
      dark:bg-gray-600
      shadow
      dark:shadow-lg
      rounded
      opacity-70
      m-0
      mt-6
      ;

      &__cc, &__pn {
        @apply
        p-4
        ;
      }

      .nuxt-content {
        @apply
        relative
        p-4
        ;

        p {
          @apply text-lg py-1;
        }

        h1 {
          @apply text-4xl mt-4 mb-4;
        }

        h2 {
          @apply text-3xl mt-4 mb-4;
        }

        h3 {
          @apply text-2xl mt-4 mb-4;
        }

        h4 {
          @apply text-xl mt-4 mb-4;
        }

        h5 {
          @apply text-lg mt-4 mb-4;
        }

        h6 {
          @apply text-base mt-4 mb-4;
        }

        ul, ol {
          @apply m-4 text-base;

          li {
            @apply mx-4 my-2 list-disc;

            &:first-child {
              @apply mt-0;
            }

            &:last-child {
              @apply mb-0;
            }
          }
        }

        p > a {
          @apply
          bg-gray-200
          text-gray-800
          px-2
          py-1
          ring-2
          ring-blue-500
          ring-inset
          text-xs
          align-middle
          rounded
          ;
        }

        ol {
          li {
            @apply list-decimal;
          }
        }

        > p > code, h1 > code, h2 > code, h3 > code, h4 > code, h5 > code, h6 > code {
          @apply
          rounded-sm
          px-1
          py-1
          shadow
          bg-gray-700
          text-gray-200
          text-sm
          align-middle
          ;
        }

        &-highlight {
          > span[class='filename'] {
            @apply
            text-right
            absolute
            right-4
            text-gray-700
            px-2
            py-2
            ;
          }

          @apply text-sm;

          > pre {
            @apply
            rounded-md
            pt-8
            ;
          }
        }
      }
    }

    &__header, &__footer {
      @apply
      my-4
      relative
      p-4
      ;

      ul {
        @apply sm:flex sm:justify-end text-gray-600 dark:text-gray-300;

        li {
          @apply sm:inline-block block mr-2;

          &:last-child {
            @apply mr-0;
          }

          svg {
            @apply
            inline-block
            w-6
            h-6
            fill-current
            xs:mr-2
            ;
          }

          a {
            span {
              @apply
              sm:hidden
              xs:inline-block
              align-middle
              ;
            }
          }
        }
      }
    }
  }
}
</style>
